@import '../../styles/common';

$textfield-horizontal-spacing: spacing(none);
$textfield-backdrop-offset: -(border-width(thick));
$backdrop-horizontal-spacing: spacing(tight) * 1.5;
$addon-horizontal-spacing: 0.25em;
$spinner-icon-size: rem(12px);
$prefix-horizontal-spacing: spacing(tight);

$stacking-order: (
  contents: 20,
  backdrop: 10,
);

.TextField {
  @include text-style-input;
  position: relative;
  display: flex;
  align-items: center;
  color: var(--p-text);
  cursor: text;

  svg {
    fill: var(--p-icon);
  }
}

.multiline {
  padding: 0;
  flex-wrap: wrap;

  > .Input {
    border-bottom: 0 !important;
    overflow: auto;
    resize: none;
  }

  &:hover,
  &:focus,
  &:active {
    border-bottom: 0;
  }
}

.hasValue {
  color: var(--p-text);
}

.focus > .Input,
.Input:focus {
  border-bottom: border(dark);
  outline: none;

  // stylelint-disable-next-line selector-max-class, selector-max-combinators, selector-max-specificity
  ~ .Backdrop {
    @include focus-ring($style: 'focused');
  }
}

.error {
  .Input::placeholder {
    // This is the only place this color is used.
    // stylelint-disable-next-line color-no-hex
    color: #9c9798;
  }

  // stylelint-disable-next-line selector-max-class, selector-max-combinators
  > .Input ~ .Backdrop {
    background-color: var(--p-surface-critical-subdued);
    border-color: var(--p-border-critical);

    // stylelint-disable-next-line selector-max-class, selector-max-combinators, selector-max-specificity
    &::after {
      border-color: var(--p-focused);
    }
  }
}

.readOnly > .Backdrop {
  background-color: var(--p-action-secondary-disabled);
}

.disabled {
  color: var(--p-text-disabled);
  cursor: initial;

  > .Backdrop {
    background-color: var(--p-surface-disabled);
    border-top-color: var(--p-border-disabled);
  }

  svg {
    fill: var(--p-icon-disabled);
  }
}

.Input {
  @include text-style-input;
  position: relative;
  z-index: z-index(contents, $stacking-order);
  display: block;
  flex: 1 1 0%;
  width: 100%;
  min-width: 0;
  min-height: 0;
  margin: 0;
  // padding: control-vertical-padding() $textfield-horizontal-spacing;
  padding: 0 0 rem(5px) 0; //We are applying this because, by default styles are applied for input field from user agent stylsheet.
  background: none;
  border: border(transparent);
  border-bottom: border(base);
  font-family: inherit;
  font-size: inherit;
  font-weight: inherit;
  appearance: none;
  caret-color: var(--p-text);
  color: var(--p-text);

  .Prefix + & {
    padding-left: 0;
    margin-top: 8px;
  }

  &:disabled {
    opacity: 1;
    background: none;
    color: var(--p-text-disabled);
    -webkit-text-fill-color: var(--p-text-disabled);
  }

  // remove the box shadow in Firefox when the input is invalid
  &:invalid {
    box-shadow: none;
  }

  &::placeholder {
    color: var(--p-text-disabled);
  }

  // These properties are used to remove the default "spinner" controls
  // for number fields, since we add our own, custom versions instead.
  &[type='number'] {
    appearance: textfield;

    &::-webkit-outer-spin-button,
    &::-webkit-inner-spin-button {
      appearance: none;
      margin: 0;
    }
  }

  &:-webkit-autofill {
    border-radius: var(--p-border-radius-base);
  }

  &:hover {
    border-bottom: border(divider);
  }
  &:focus:hover {
    border-bottom: border(dark);
  }
  &:active {
    border-bottom: border(dark);
  }
}

.Input-hasClearButton {
  // Hide webkit search input clear button
  &[type='search'] {
    &::-webkit-search-cancel-button {
      appearance: none;
    }
  }
}

.Input-suffixed {
  padding-right: 0;
  margin-top: 8px;
}

.Input-alignRight {
  text-align: right;
}

.Input-alignLeft {
  text-align: left;
}

.Input-alignCenter {
  text-align: center;
}

.Backdrop {
  // @include focus-ring($border-width: border-width());
  position: absolute;
  z-index: z-index(backdrop, $stacking-order);
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  background-color: var(--p-surface);
  border-top-color: var(--p-border-shadow);
  border-radius: var(--p-border-radius-base);
  pointer-events: none;
}

.Prefix,
.Suffix {
  position: relative;
  z-index: z-index(contents, $stacking-order);
  flex: 0 0 auto;
  color: var(--p-text-subdued);
  user-select: none;
}

.Prefix {
  // margin-left: $backdrop-horizontal-spacing;
  // margin-right: $prefix-horizontal-spacing;
}

.Suffix {
  // margin-left: $addon-horizontal-spacing;
  // margin-right: $backdrop-horizontal-spacing;
}

.CharacterCount {
  @include text-emphasis-subdued;
  z-index: z-index(contents, $stacking-order);
  margin: 0 $backdrop-horizontal-spacing 0 $addon-horizontal-spacing;
  pointer-events: none;
  text-align: right;
}

.AlignFieldBottom {
  align-self: flex-end;
  width: 100%;
  padding-bottom: spacing(tight);
}

.ClearButton {
  @include focus-ring;
  @include unstyled-button;
  z-index: z-index(contents, $stacking-order);
  margin: 0 $backdrop-horizontal-spacing 0 $addon-horizontal-spacing;

  &:focus:enabled {
    @include focus-ring($style: 'focused');
  }

  &:disabled {
    cursor: default;
  }
}

.Spinner {
  --p-text-field-spinner-offset-large: calc(
    var(--p-text-field-spinner-offset) + #{border-width()}
  );
  z-index: z-index(contents, $stacking-order);
  margin: var(--p-text-field-spinner-offset-large);
  color: var(--p-icon);
  display: flex;
  align-self: stretch;
  flex-direction: column;
  width: rem(22px);
  cursor: pointer;
}

.SpinnerIcon {
  height: $spinner-icon-size;
  width: $spinner-icon-size;
}

.Resizer {
  position: absolute;
  bottom: 0;
  left: 0;
  right: 0;
  height: 0;
  visibility: hidden;
  overflow: hidden;
}

.DummyInput {
  @include text-style-input;
  padding: control-vertical-padding() $backdrop-horizontal-spacing;

  // We need the following properties in order to have long, unbroken
  // strings wrap in the same way they do in textareas.
  @include text-breakword;
  white-space: pre-wrap;
}

.Segment {
  --p-text-field-spinner-border-radius: calc(
    var(--p-border-radius-base) - var(--p-text-field-spinner-offset)
  );
  background: var(--p-surface-neutral);
  border-radius: var(--p-text-field-spinner-border-radius);
  display: flex;
  flex: 1 1 0%;
  justify-content: center;
  align-items: center;
  appearance: none;
  border: none;

  &:focus {
    outline: none;
  }

  &:active {
    background: var(--p-surface-neutral-pressed);
  }

  &:first-child {
    border-top-right-radius: var(--p-text-field-spinner-border-radius);
    margin-bottom: var(--p-text-field-spinner-offset);
  }

  &:last-child {
    border-bottom-right-radius: var(--p-text-field-spinner-border-radius);
  }

  &:not(:first-child) {
    margin-top: 0;
  }
}

.monospaced {
  font-family: font-family($family: 'monospace');
}
